' FF Submenu=Exif			
' FF Name=Rating F6			
' Schreibt Rating-Information in den Exif-Block
' Aufruf aus der Gesamtbildschirmansicht mit F8
' KGsoft (praetor)
' Version 1.0 	vom 30.01.2014		erste ffentliche Version
' Version 1.1 	vom 31.01.2014		Reparatur EIN Stern, Test auf JPG
' Version 1.2 	vom 02.02.2014		Ergebnismeldung, Skript endet automatisch
' Version 1.3 	vom 04.02.2014		Sterne wirken als Schalter
' Version 1.4 	vom 08.02.2014		auch Zifferntasten 0 bis 5, Mlleimer

Option Explicit
const DialName = "Rating   V1.4"
Dim Pfad, Taste, x, y
Dim RatingStern, RatingProzent
Dim Erfolg
Dim st1, st2, st3, st4, st5
Dim WshShell

Pfad = FF_GetParam()
REM Pfad = FF_GetImageName(-1)		' Name des aktuellen Bildes
REM FF_MessageBox pfad,0			' nur fr Test
if FF_IdentifyImage(Pfad) = 2 Then	' Rating-Infos nur fr JPG mglich
	Call Exif_Lesen
	Call Dialog_Aufbau
	Call Buttonbilder
	Call Dialog_Abfrage
Else
	x = FF_MessageBox ("Kein JPG, in diesem Bild kann eine Bewertung nicht hinterlegt werden.", 64)
End If

Sub Exif_Lesen
	FF_LoadExif (Pfad)
	IF FF_HasExif() then
		RatingStern = FF_GetExifTag("Rating")
	End If
	If RatingStern = "" then RatingStern = 0
End Sub

Sub Dialog_Abfrage
	REM FF_ActivateControl DialName, "rat1_button"		' Fokus auf Stern 1	' vertrgt sich nicht mit TIMER?
	FF_SetControl DialName,"txt_img", FF_GetFFPathEx(2) & "\Rating\text_info.png"
	FF_SetDialogTimer DialName, 100  
	Do						' Auswertung Button im Dialog
		Taste = FF_ShowDialog(DialName)
		Select Case Taste
			Case "TIMER"
				If FF_GetAsyncKeyState(48) or FF_GetAsyncKeyState(96) then	' 0 auf  Tastatur oder Nummernblock
					RatingStern = 0
					RatingProzent = 0
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
				If FF_GetAsyncKeyState(49) or FF_GetAsyncKeyState(97) then	' 1 auf  Tastatur oder Nummernblock 
					RatingStern = 1
					RatingProzent = 1
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
				If FF_GetAsyncKeyState(50) or FF_GetAsyncKeyState(98) then 
					RatingStern = 2
					RatingProzent = 25
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
				If FF_GetAsyncKeyState(51) or FF_GetAsyncKeyState(99) then 
					RatingStern = 3
					RatingProzent = 50
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
				If FF_GetAsyncKeyState(52) or FF_GetAsyncKeyState(100) then 
					RatingStern = 4
					RatingProzent = 75
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
				If FF_GetAsyncKeyState(53) or FF_GetAsyncKeyState(101) then 
					RatingStern = 5
					RatingProzent = 100
					Call Exif_Schreiben
					FF_CloseDialog DialName
					Exit Do
				End If
			Case "del_button"
				RatingStern = 0
				RatingProzent = 0
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "rat1_button"
				RatingStern = 1
				RatingProzent = 1
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "rat2_button"
				RatingStern = 2
				RatingProzent = 25
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "rat3_button"
				RatingStern = 3
				RatingProzent = 50
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "rat4_button"
				RatingStern = 4
				RatingProzent = 75
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "rat5_button"
				RatingStern = 5
				RatingProzent = 100
				Call Exif_Schreiben
				FF_CloseDialog DialName
				Exit Do
			Case "CANCEL"
				Exit Sub
		End Select
	Loop
	Call Dialog_Aufbau
	Call Buttonbilder
	' nach Setzen des Wertes
	if Erfolg = True Then
		FF_SetControl DialName,"txt_img", FF_GetFFPathEx(2) & "\Rating\text_erfolg.png"
	Else
		FF_SetControl DialName,"txt_img", FF_GetFFPathEx(2) & "\Rating\text_error.png"
	End If
	FF_OpenDialog DialName 
	FF_Sleep 1000
	FF_CloseDialog DialName
	Exit Sub
End Sub

Sub Exif_Schreiben
	FF_LoadExif (Pfad)
	IF not FF_HasExifInFile (Pfad) then		' Exif-Block fehlt noch
		FF_CreateExifInFile Pfad
		FF_LoadExif (Pfad)					' nach Erzeugung Exif-Block erneutes Laden notwendig
	End If
	Erfolg = FF_SetExifTag ("Rating", RatingStern)
	FF_SetExifTag "RatingPercent", RatingProzent
	FF_SaveExif Pfad
	if  Version_equal_or_better("3.50.11") then
		FF_UpdateThumbDB Pfad 
	End if
End Sub

Sub Dialog_Aufbau
	'** Start Dialog DialName **
	FF_AddDialog DialName,108,30
	FF_AddControl DialName,"rat1_button","BUTTON",18,0,18,18
	FF_AddControl DialName,"rat2_button","BUTTON",36,0,18,18
	FF_AddControl DialName,"rat3_button","BUTTON",54,0,18,18
	FF_AddControl DialName,"rat4_button","BUTTON",72,0,18,18
	FF_AddControl DialName,"rat5_button","BUTTON",90,0,18,18
	FF_AddControl DialName,"txt_img","IMAGE",0,19,108,11
	FF_AddControl DialName,"del_button","BUTTON",0,0,18,18
	'** End Dialog DialName **
	FF_SetControlImage DialName,"del_button", FF_GetFFPathEx(2) & "\Rating\" & "muelleimer1.png"
End Sub

Sub Buttonbilder
	if RatingStern <> "" Then
		Select Case RatingStern
			Case 0 
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
			Case 1
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
			Case 2
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
			Case 3
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
			Case 4
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
			Case 5
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_voll.png"
			case 0, ""
				FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
				FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
		End Select
	Else
		FF_SetControlImage DialName, "rat1_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
		FF_SetControlImage DialName, "rat2_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
		FF_SetControlImage DialName, "rat3_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
		FF_SetControlImage DialName, "rat4_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
		FF_SetControlImage DialName, "rat5_button", FF_GetFFPathEx(2) & "\Rating\" & "stern_leer.png"
	End If
End Sub

Function Version_equal_or_better(p_Vers)
     Dim l_VersNr
     l_VersNr=split(p_Vers,".")
     version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000 >= l_VersNr(0)*1000+l_VersNr(1)+l_VersNr(2)/1000)
End Function
